#ifndef _DEFINES_
#define _DEFINES_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <GL/glut.h>
#include <GL/glx.h>
#include <sys/timeb.h>

#define INIT_W 512
#define INIT_H 512
#define PI 3.141592654

#define NUMOBJS 3
#define NUMSHIPS 7

#define MAXLINE_READ 384

// Higher this goes, the slower the camera will transition between
// objects and views
#define TRANSITION_FACTOR 1.0

// parseraw.c
void read_raw_obj(char *, int);

void myinit(void);
void myReshape(GLsizei, GLsizei);
void reshape_perspective(GLsizei, GLsizei);
void key(unsigned char, int, int);
void readextobjs(void);
void drawextobj(int, GLfloat);
void cross_prod(int, int);
void init_ships(void);
void updatevalues(void);
void predisplay(void);
void display(void);

void shuttle(float, float);
void ssd(float);
void stardestroyer(float);
void tiefighter(float);
void tdrect(GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);

// External object struct
typedef struct external_objects{
	GLfloat *vx;
	GLfloat *vy;
	GLfloat *vz;
	int numvertices;
} external_objects;

// From pg.124 in OpenGL primer
typedef struct materialStruct{
	GLfloat ambient[4];	
	GLfloat diffuse[4];
	GLfloat specular[4];
	GLfloat shininess;
}materialStruct;

void setMaterials(materialStruct *,GLint);

extern materialStruct redlaser;
extern materialStruct bluesolarpanels;
extern materialStruct gengrey;
extern materialStruct bluengines;
extern materialStruct Brass;
extern materialStruct Bronze;
extern materialStruct Polished_Bronze;
extern materialStruct Chrome;
extern materialStruct Copper;
extern materialStruct Polished_Copper;
extern materialStruct Gold;
extern materialStruct Polished_Gold;
extern materialStruct Pewter;
extern materialStruct Silver;
extern materialStruct Polished_Silver;
extern materialStruct Emerald;
extern materialStruct Jade;
extern materialStruct Obsidian;
extern materialStruct Pearl;
extern materialStruct Ruby;
extern materialStruct Turquoise;
extern materialStruct Black_Plastic;
extern materialStruct Black_Rubber;

#endif
